/**
* Preset resources for Tweet 2 Unlock
* for jQuery: http://onepress-media.com/plugin/tweet-2-unlock-for-twitter/get
* for Wordpress: http://onepress-media.com/plugin/tweet-2-unlock-for-twitter-wordpress/get
*
* Copyright 2012, OnePress, http://onepress-media.com/portfolio
* Help Desk: http://support.onepress-media.com/
*/

(function ($) {

    if (!$.onepress) $.onepress = {};
    if (!$.onepress.lang) $.onepress.lang = {};

    $.onepress.lang.totweet = {

        defaultMessage: 'This content is locked. Please support us, tweet to view the hidden content.',
        orWait: 'or wait',
        close: 'Close'
    };
})(jQuery);;;

/**
* Helper Tools:
* - cookies getter/setter
* - md5 hasher
* - lightweight widget factory
*
* Copyright 2012, OnePress, http://onepress-media.com/portfolio
* Help Desk: http://support.onepress-media.com/
*/


(function ($) {
    'use strict';

    if (!$.onepress) $.onepress = {};
    if (!$.onepress.tools) $.onepress.tools = {};

    /*
    * Cookie's function.
    * Allows to set or get cookie.
    *
    * Based on the plugin jQuery Cookie Plugin
    * https://github.com/carhartl/jquery-cookie
    *
    * Copyright 2011, Klaus Hartl
    * Dual licensed under the MIT or GPL Version 2 licenses.
    * http://www.opensource.org/licenses/mit-license.php
    * http://www.opensource.org/licenses/GPL-2.0
    */
    $.onepress.tools.cookie = $.onepress.tools.cookie || function (key, value, options) {

        // Sets cookie
        if (arguments.length > 1 && (!/Object/.test(Object.prototype.toString.call(value)) || value === null || value === undefined)) {
            options = $.extend({}, options);

            if (value === null || value === undefined) {
                options.expires = -1;
            }

            if (typeof options.expires === 'number') {
                var days = options.expires, t = options.expires = new Date();
                t.setDate(t.getDate() + days);
            }

            value = String(value);

            return (document.cookie = [
                encodeURIComponent(key), '=', options.raw ? value : encodeURIComponent(value),
                options.expires ? '; expires=' + options.expires.toUTCString() : '',
                options.path ? '; path=' + options.path : '',
                options.domain ? '; domain=' + options.domain : '',
                options.secure ? '; secure' : ''
            ].join(''));
        }

        // Gets cookie.
        options = value || {};
        var decode = options.raw ? function (s) { return s; } : decodeURIComponent;

        var pairs = document.cookie.split('; ');
        for (var i = 0, pair; pair = pairs[i] && pairs[i].split('='); i++) {
            if (decode(pair[0]) === key) return decode(pair[1] || '');
        }
        return null;
    };

    /*
    * jQuery MD5 Plugin 1.2.1
    * https://github.com/blueimp/jQuery-MD5
    *
    * Copyright 2010, Sebastian Tschan
    * https://blueimp.net
    *
    * Licensed under the MIT license:
    * http://creativecommons.org/licenses/MIT/
    * 
    * Based on
    * A JavaScript implementation of the RSA Data Security, Inc. MD5 Message
    * Digest Algorithm, as defined in RFC 1321.
    * Version 2.2 Copyright (C) Paul Johnston 1999 - 2009
    * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
    * Distributed under the BSD License
    * See http://pajhome.org.uk/crypt/md5 for more info.
    */
    $.onepress.tools.hash = $.onepress.tools.hash || function (str) {

        var hash = 0;
        if (str.length == 0) return hash;
        for (var i = 0; i < str.length; i++) {
            var charCode = str.charCodeAt(i);
            hash = ((hash << 5) - hash) + charCode;
            hash = hash & hash;
        }
        hash = hash.toString(16);
        hash = hash.replace("-", "0");

        return hash;
    };


    /**
    * OnePress Widget Factory.
    * Supports:
    * - creating a jquery widget via the standart jquery way
    * - call of public methods.
    */
    $.onepress.widget = function (pluginName, pluginObject) {

        var factory = {

            createWidget: function (element, options) {
                var widget = $.extend(true, {}, pluginObject);

                widget.element = $(element);
                widget.options = $.extend(true, widget.options, options);

                if (widget._init) widget._init();
                if (widget._create) widget._create();

                $.data(element, 'plugin_' + pluginName, widget);
            },

            callMethod: function (widget, methodName) {
                widget[methodName] && widget[methodName]();
            }
        };

        $.fn[pluginName] = function () {
            var args = arguments;
            var argsCount = arguments.length;

            this.each(function () {

                var widget = $.data(this, 'plugin_' + pluginName);

                // a widget is not created yet
                if (!widget && argsCount <= 1) {
                    factory.createWidget(this, argsCount ? args[0] : false);

                    // a widget is created, the public method with no args is being called
                } else if (argsCount == 1) {
                    factory.callMethod(widget, args[0]);
                }
            });
        };
    };

})(jQuery);;;

/**
* Twitter SDK connector
*
* Copyright 2012, OnePress, http://onepress-media.com/portfolio
* Help Desk: http://support.onepress-media.com/
*/

(function ($) {
    'use strict';

    if (!$.onepress) $.onepress = {};
    if ($.onepress.twitter) return;

    /**
    * Twitter API wrapper
    */
    $.onepress.twitter = {

        _sdkScriptId: "twitter-wjs",

        // is Javascript SDK inited?
        _isSdkConnected: false,
        _isSdkLoaded: false,

        loadSDK: function (callback) {

            var id = this._sdkScriptId;

            if (callback) {
                if (this._isSdkLoaded) callback();
                else this.bind("tw-init", function () { callback(); });
            }

            // Loads a Twitter SDK asynchronously.
            window.twttr = (function (d, s, id) {

                var t, js, fjs = d.getElementsByTagName(s)[0];
                js = d.createElement(s); js.id = id;
                js.src = "//platform.twitter.com/widgets.js"; fjs.parentNode.insertBefore(js, fjs);
                return window.twttr || (t = { _e: [], ready: function (f) { t._e.push(f); } });

            } (document, "script", id));

            // Subscribes to events.
            this._createEvents();
        },

        _createEvents: function () {
            var self = this;
            self._isReadyFired = false;

            twttr.ready(function (twttr) {
                if (self._isReadyFired) return;
                self._isReadyFired = true;
                
                twttr.events.bind('tweet', function (event) {
                    $(document).trigger('tw-tweet', [event.target, event.data]);
                });

                twttr.events.bind('follow', function (event) {
                    $(document).trigger('tw-follow', [event.target, event.data]);
                });

                self._isSdkLoaded = true;
                $(document).trigger('tw-init');
            });

        },

        bind: function (name, callback) {
            $(document).bind(name, callback);
        },

        isLogged: function (callback) {

            // if a login state was got
            if (this._isLoginChecked) {
                return callback(this._isLoggetInto);
            }

            var self = this;

            // if a login state is being checking right now by other locker 
            if (this._loginStateisChecking) {
                return $(document).bind("tw-is-logged", function () {
                    callback(self._isLoggetInto);
                });
            }

            // checking login state
            this._loginStateisChecking = true;

            var completeFunction = function (state) {

                self._isLoginChecked = true;
                self._isLoggetInto = state;
                self._loginStateisChecking = false;

                callback(state);
                $(document).trigger('tw-is-logged');
            };

            var checkImg = $("<img>");

            checkImg.bind('load', function () {
                completeFunction(true);
            });
            checkImg.bind('error', function () {
                completeFunction(false);
            });

            checkImg.attr('src', 'https://twitter.com/login?redirect_after_login=%2Fimages%2Fspinner.gif');
            checkImg.css('display', 'none');
            checkImg.appendTo('body');
        }
    };

    // It's important double wrap to execute this code at the end of the event "onload". 
    $(function () {
        $(function () {
            $.onepress.twitter.loadSDK();
        });
    });
})(jQuery);;;

/**
* Twitter Buttn widget for jQuery
*
* Copyright 2012, OnePress, http://onepress-media.com/portfolio
* Help Desk: http://support.onepress-media.com/
*/

(function ($) {
    'use strict';
    if ($.fn.twitterBtn) return;
    
    $.onepress.widget("twitterBtn", {

        options: {},

        _defaults: {

            // - Properties

            // tweet or follow button
            type: 'tweet',

            // - Twitter Options

            // URL of the page to share or follow.
            url: null,
            // Screen name of the user to attribute the Tweet to
            via: null,
            // The user's screen name shows up by default, but you can opt not to 
            // show the screen name in the button. 
            showScreenName: false,
            // Default Tweet text
            text: null,
            // Related accounts
            related: null,
            // Count box position (none, horizontal, vertical)
            count: 'horizontal',
            // By default, the User's followers count is not displayed with the Follow Button. You can enable the display of this number.
            showCount: true,
            // The language for the Tweet Button
            lang: 'en',
            // URL to which your shared URL resolves
            counturl: null,
            // 	Comma separated hashtags appended to tweet text
            hashtags: null,
            // (left or right)
            alignment: null,
            // The size of the rendered button (medium, large)
            size: 'large',
            // Twitter buttons on your site can help Twitter tailor content and suggestions for Twitter users.
            // If you want to opt-out of this feature, set the optional data-dnt parameter to be true.
            dnt: false,

            // - Events

            render: null,
            tweet: null,
            follow: null
        },

        _create: function () {

            this._prepareOptions();
            this._setupEvents();

            this.element.data('twitter-widget', this);
            this._createButton();
        },

        _prepareOptions: function () {

            var values = $.extend({}, this._defaults);

            for (var prop in this._defaults) {
                if (this.element.data(prop) !== undefined) values[prop] = this.element.data(prop);
            }

            this.options = $.extend(values, this.options);

            // Url
            if (!this.options.url && $("link[rel='canonical']").length > 0)
                this.options.url = $("link[rel='canonical']").attr('href');

            this.url = (!this.options.url) ? window.location : this.options.url;

            // Hashtags
            if (this.options.hashtags instanceof Array) {

                var tagString = '';
                var length = hashtags.lenght;
                var counter = 1;

                for (var index in hashtags) {
                    tagString = tagString + hashtags[index];
                    if (counter < length) {
                        tagString = tagString + ",";
                    }
                    counter++;
                }

                this.options.hashtags = tagString;
            }
        },

        _setupEvents: function () {
            var self = this;

            $(document).bind('tw-init', function (e) {
                if (self.options.init) self.options.init();
            });

            $(document).bind('tw-tweet', function (e, target, data) {
                if (self.options.type != 'tweet') return;

                var url = $(target).parent().data('url-to-compare');
                if (self.options.tweet && self.url == url) {
                    self.options.tweet(url, target, data, self);
                }
            });

            $(document).bind('tw-follow', function (e, target, data) {
                if (self.options.type != 'follow') return;

                var url = $(target).parent().data('url-to-compare');
                            alert(this.url);
                if (self.options.follow && self.url == url) {
                    self.options.follow(target, data, self);
                }
            });

            $(this.element).bind('tw-render', function (e, target) {

                if (self.options.render) {
                    self.options.render(self.element, [self]);
                }
            });
        },

        /**
        * Generates an html code for the button using specified options.
        */
        _createButton: function () {

            var $wrap;

            // What will title be used?
            var title;
            if (this.options.type == 'follow') {
                title = 'Follow Me';
                if (!this.options.url) title = "[error] please setup an URL of your Twitter account.";
            } else {
                title = 'Tweet';
            }

            this.button = $("<a href='https://twitter.com/share'>" + title + "</a>");
            this.button.data('twitter-widget', this);

            if (this.options.type == 'follow') {
                this.button.attr('href', this.options.url);
            } else {
                this.button.attr("data-url", this.url);
            }

            if (this.options.via) this.button.attr("data-via", this.options.via);
            if (this.options.text) this.button.attr("data-text", this.options.text);
            if (this.options.related) this.button.attr("data-related", this.options.related);
            if (this.options.count) this.button.attr("data-count", this.options.count);
            if (this.options.lang) this.button.attr("data-lang", this.options.lang);
            if (this.options.counturl) this.button.attr("data-counturl", this.options.counturl);
            if (this.options.hashtags) this.button.attr("data-hashtags", this.options.hashtags);
            if (this.options.alignment) this.button.attr("data-alignment", this.options.alignment);
            if (this.options.size) this.button.attr("data-size", this.options.size);
            this.button.attr("data-show-count", this.options.showCount);
            if (this.options.dnt) this.button.attr("data-dnt", this.options.dnt);
            if (this.options.showScreenName)
                this.button.attr("data-show-screen-name", this.options.showScreenName);

            this.element.addClass('ui-social-button ui-twitter');
            this.element.attr('data-url-to-compare', this.url);
            
            if (this.options.type == 'tweet') {
                this.element.addClass('ui-twitter-tweet');
                this.button.addClass('twitter-share-button');
            }
            if (this.options.type == 'follow') {
                this.element.addClass('ui-twitter-follow');
                this.button.addClass('twitter-follow-button');
            }

            this.element.append(this.button);
        },

        getHtmlToRender: function () {
            return this.button;
        }
    });

    $.fn.tweetBtn = function (opts) {

        opts = $.extend({}, opts);
        opts.type = 'tweet';
        $(this).twitterBtn(opts);
    };

    $.fn.followBtn = function (opts) {

        opts = $.extend({}, opts);
        opts.type = 'follow';
        $(this).twitterBtn(opts);
    };

})(jQuery);;;

/**
* Tweet 2 Unlock
* for jQuery: http://onepress-media.com/plugin/tweet-2-unlock-for-twitter/get
* for Wordpress: http://onepress-media.com/plugin/tweet-2-unlock-for-twitter-wordpress/get
*
* Copyright 2012, OnePress, http://onepress-media.com/portfolio
* Help Desk: http://support.onepress-media.com/
*/

(function ($) {
    'use strict';
    if ($.fn.toTweet) return;

    $.onepress.widget("toTweet", {

        options: {
            locker: {},
            effects: {},
            style: {},
            twitter: {}
        },

        // The variable stores a current content state.
        isLocked: false,

        // Provided used to check whether the Like Buttons was clicked.
        _provider: null,

        // Defauls option's values.
        _defaults: {

            // Url to process.
            url: null,

            // a message that appears inside the locker 
            text: $.onepress.lang.totweet.defaultMessage,

            // adds exta classes here (for example, classes of the built-in themes).	
            style: null,

            // sets to false to turn of the highlight effect
            highlight: true,

            // sets whether the locker appears always
            demo: false,

            // -
            // Main locker configuration settings.
            // -
            locker: {
                // set true to show a Like Buttom above the locker
                inverse: false,
                // set true to turn on the closing cross on the corner
                close: false,
                // set positive integer for the Timer
                timer: false,
                // set false to turn off the locker for mobiele users
                mobile: true,
                // set true to show the locker only for loggged google users
                loggedOnly: false,
                // set watch dog interval to unlock content if some troubles are going
                watchdog: 15000
            },

            // -
            // Tweeter options.
            // -
            twitter: {

                // tweet or follow button
                type: 'tweet',
                // Title for the botton
                title: null,

                // URL of the page to share
                url: null,
                // Screen name of the user to attribute the Tweet to
                via: null,
                // Default Tweet text
                text: null,
                // Related accounts
                related: null,
                // Count box position (none, horizontal, vertical)
                count: 'horizontal',
                // By default, the User's followers count is not displayed with the Follow Button. You can enable the display of this number.
                showCount: true,
                // The language for the Tweet Button
                lang: 'en',
                // URL to which your shared URL resolves
                counturl: null,
                // 	Comma separated hashtags appended to tweet text
                hashtags: null,
                // (left or right)
                alignment: null,
                // The size of the rendered button (medium, large)
                size: 'large',
                // Twitter buttons on your site can help Twitter tailor content and suggestions for Twitter users.
                // If you want to opt-out of this feature, set the optional data-dnt parameter to be true.
                dnt: false
            },

            // -
            // Content that will be showen after unlocking.
            // -
            content: null,

            // -
            // Events
            // -
            events: {

                // when content is locked
                lock: null,
                // when content is unlocked
                unlock: null,
                // when content is unlocked by the Time
                unlockByTimer: null,
                // when content is unlocked by the Close Button
                unlockByClose: null,
                // when content is unlocked by the WatchDog
                unlockByWatchdog: null,
                // when a locker is created and inited
                ready: null
            }
        },

        _create: function () {
            var self = this;
            this._parseOptions();

            // if it's a mobile device and the option Mobile is set to True, don't create a locker
            // the lite method to check is used 
            // http://stackoverflow.com/questions/3514784/best-way-to-detect-handheld-device-in-jquery

            // check mobile devices
            if (!this.options.locker.mobile && this._isMobile()) {
                this._preUnlock("mobile");
                return;
            }

            this._provider = new $.onepress.localTwitterStoreStateProvider(this.url, this, this.options.demo);

            // continue if there is no erros
            if (this._error) { this.element.show(); return; }

            // if loggedOnly is false or content is unlocked, no need to check the login state
            if (!this.options.locker.loggedOnly || self._provider.isUnlocked()) {

                var state = self._provider.isUnlocked();
                !state ? self._lock("provider") : self._unlock("provider");
                if (self.options.events.ready) self.options.events.ready(state ? "unlocked" : "locked");
                return;
            }

            this._createMarkup();
            this._setLoadingState(true);

            self._runWatchdog('[twitter-locker-check-login]');

            this._checkLogin(function (loggedInTwitter) {
                // [twitter-locker-check-login]
                self._stopWatchdog();

                loggedInTwitter ? self._lock("provider") : self._unlock("provider");
                if (self.options.events.ready) self.options.events.ready("locked");
            });
        },

        /**
        * Returns true if a current user use a mobile device, else false.
        */
        _isMobile: function () {
            return (/Android|webOS|iPhone|iPod|BlackBerry/i.test(navigator.userAgent));
        },

        // --------------------------------------------------------------------------------------
        // Options parsing
        // --------------------------------------------------------------------------------------

        _parseOptions: function () {

            var options = $.extend(true, {}, this._defaults, this.options);

            if (!options.text) options.text = $.onepress.lang.totweet.defaultMessage;

            options.text = (typeof options.text === "function" && options.text(this)) ||
                           (typeof options.text === "string" && $("<div>" + options.text + "</div>")) ||
                           (typeof options.text === "object" && options.text.clone());

            if (options.locker.timer && !parseInt(options.locker.timer)) options.locker.timer = null;

            this.url = this.url || this.options.url || window.location.href;
            this.identity = $.onepress.tools.hash(this.url);
            this.element.addClass("identity-" + this.identity).addClass("ui-locker-content");

            this.options = options;
        },

        // --------------------------------------------------------------------------------------
        // Service methods
        // --------------------------------------------------------------------------------------

        /**
        * WatchDog is a simple mechanism to show content in the case when something is going wrong.
        * For example, the SDK is being loading too long (low internet speed).
        */
        _runWatchdog: function (uniqueLabel) {
            if (!this.options.locker.watchdog) return;
            var self = this;

            this._watchdog = setTimeout(function () {

                self._stoppedByWatchdog = true;
                self._unlock("watchdog");

                if (uniqueLabel && console) {
                    var text = "Watchdog: " + uniqueLabel;
                    (console.debug && console.debug(text)) || (console.log && console.log(text));
                }
            }, this.options.locker.watchdog);
        },

        _stopWatchdog: function () {

            if (!this._watchdog) return;
            clearTimeout(this._watchdog);
            this._watchdog = null;
        },

        /**
        * Checks is a user logged into Facebook
        */
        _checkLogin: function (callback) {

            $.onepress.twitter.loadSDK(function () {
                $.onepress.twitter.isLogged(function (result, loggedInTwitterPlus) {
                    callback(result, loggedInTwitterPlus);
                });
            });
        },

        /**
        * Sets a loading state.
        */
        _setLoadingState: function (stateFlag) {
            if (!stateFlag) { if (this.loadingState) this.loadingState.remove(); return; }

            var after = (this.element.parent().is('a')) ? this.element.parent() : this.element;
            this.loadingState = $("<div class='ui-locker-loading-holder'></div>").insertAfter(after);
            this.element.hide();
        },

        /**
        * Sets an error state.
        */
        _setError: function (text) {
            this._error = true;
            this._errorText = text;

            this._setLoadingState(false);
            this.locker && this.locker.hide();

            this.element.html("<strong>[Error]: " + text + "</strong>");
            this.element.show().addClass("ui-facebook-locker-error");
        },

        // --------------------------------------------------------------------------------------
        // Markups and others.
        // --------------------------------------------------------------------------------------

        /**
        * Creates markup of the plugin.
        */
        _createMarkup: function () {
            var self = this;

            var browser = (jQuery.browser.mozilla && 'mozilla') ||
                          (jQuery.browser.opera && 'opera') ||
                          (jQuery.browser.webkit && 'webkit') || 'msie';

            this.locker = $("<div class='ui-locker-twitter ui-locker-" + browser + "'></div>").hide();
            this.outerWrap = $("<div class='ui-locker-outer-wrap'></div>").appendTo(this.locker);
            this.innerWrap = $("<div class='ui-locker-inner-wrap'></div>").appendTo(this.outerWrap);
            this.element.addClass("ui-locker-content");

            this.locker.addClass(this.options.style);

            if (this.options.twitter.type == 'tweet') {
                this.locker.addClass('ui-locker-button-tweet');
            }

            // Inner text defined by a user.
            this.options.text.addClass("ui-locker-text").show();

            this.options.text.prepend(($("<div class='ui-locker-decorator-3'></div>")));
            this.options.text.append(($("<div class='ui-locker-decorator-4'></div>")));

            // wrapper of social buttons
            this.buttonsWrap = $("<div class='ui-locker-buttons'></div>");
            this.buttonWrap = $("<div class='ui-locker-button'></div>").appendTo(this.buttonsWrap);
            this.buttonsWrap.prepend($("<div class='ui-locker-decorator-5'></div>"));

            this.innerWrap.append($("<div class='ui-locker-decorator-1'></div>"));

            if (this.options.locker.inverse) {
                this.innerWrap.append(this.buttonsWrap);
                this.innerWrap.append(this.options.text);
                this.locker.addClass('ui-locker-inverse');
            } else {
                this.innerWrap.append(this.options.text);
                this.innerWrap.append(this.buttonsWrap);
            }

            this.innerWrap.append($("<div class='ui-locker-decorator-2'></div>"));
            this.buttonsWrap.append(($("<div class='ui-locker-decorator-6'></div>")));

            // Creates social buttons
            if (this._createSocialButtons) this._createSocialButtons(this.locker, this.buttonWrap);

            // close button and timer
            this.options.locker.close && this._createCloseButton();
            this.options.locker.timer && this._createTimer();

            var after = (this.element.parent().is('a')) ? this.element.parent() : this.element;
            this.locker.insertAfter(after);

            this._markupIsCreated = true;
        },

        /**
        * Creates markup for the Clsoe Button.
        */
        _createCloseButton: function () {
            var self = this;

            this.closeButton = $("<div title='" + $.onepress.lang.totweet.close + "' class='ui-locker-close-icon'></div>");
            this.closeButton.prependTo(this.locker);

            this.closeButton.click(function () {
                if (!self.close || self.close(self)) self._unlock("close");
            });
        },

        /**
        * Creates markup for timer.
        */
        _createTimer: function () {
            this.timer = $("<span class='ui-locker-timer'></span>");

            var timerLabelText = $.onepress.lang.totweet.orWait;

            this.timerLabel = $("<span class='ui-locker-timer-label'>" + timerLabelText + " </span>").appendTo(this.timer);
            this.timerCounter = $("<span class='ui-locker-timer-counter'>" + this.options.locker.timer + "s</span>").appendTo(this.timer);

            this.timer.appendTo(this.locker);

            this.counter = this.options.locker.timer;
            this._kickTimer();
        },

        /**
        * Lick the timer to perform a next iteration.
        */
        _kickTimer: function () {
            var self = this;

            setTimeout(function () {

                if (!self._isLocked) return;

                self.counter--;
                if (self.counter <= 0) {
                    self._unlock("timer");
                } else {
                    self.timerCounter.text(self.counter + "s");

                    // Opera fix.
                    if ($.browser.opera) {
                        var box = self.timerCounter.clone();
                        box.insertAfter(self.timerCounter);
                        self.timerCounter.remove();
                        self.timerCounter = box;
                    }

                    self._kickTimer();
                }
            }, 1000);
        },

        /**
        * Creates social button.
        */
        _createSocialButtons: function (locker, buttonWrap) {
            var self = this;

            var twitterOptions = $.extend({}, this.options.twitter);
            if (this.options.url) twitterOptions.url = this.options.url;

            twitterOptions.tweet = function () {
                self._unlock("button");
            };

            twitterOptions.follow = function () {
                self._unlock("button");
            };

            if (twitterOptions.type == "tweet") {
                buttonWrap.tweetBtn(twitterOptions);
            } else {
                buttonWrap.followBtn(twitterOptions);
            }
        },

        // --------------------------------------------------------------------------------------
        // Lock/Unlock content.
        // --------------------------------------------------------------------------------------

        _lock: function (typeSender, sender) {

            this._setLoadingState(false);

            if (this._isLocked || this._stoppedByWatchdog) return;
            if (!this._markupIsCreated) this._createMarkup();
            if (typeSender == "button") this._provider.setState("locked");

            this.element.hide();
            this.locker.fadeIn(1000);

            this._isLocked = true;
            if (this.options.events.lock) this.options.events.lock(this);
        },

        _unlock: function (typeSender, sender) {
            var self = this;

            this._setLoadingState(false);
            if (typeSender == "watchdog" && this.options.events.unlockByWatchdog) return this.options.events.unlockByWatchdog();

            if (!this._isLocked) { this._showContent(true); return false; }
            if (typeSender == "button") this._provider.setState("unlocked");

            this._showContent(true);

            this._isLocked = false;
            if (typeSender == "timer" && this.options.events.unlockByTimer) return this.options.events.unlockByTimer();
            if (typeSender == "close" && this.options.events.unlockByClose) return this.options.events.unlockByClose();
            if (this.options.events.unlock) this.options.events.unlock();
        },

        _preUnlock: function (type, sender) {

            this._setLoadingState(false);
            this._showContent(false);
            if (this.options.events.sready) this.options.events.ready("unlocked");
        },

        _showContent: function (useEffects) {
            var self = this;

            var effectFunction = function () {

                if (self.locker) self.locker.hide();
                if (!useEffects) { self.element.show(); return; }

                self.element.fadeIn(1000, function () {
                    self.options.highlight && self.element.effect && self.element.effect('highlight', { color: '#fffbcc' }, 800);
                });
            };

            if (!this.options.content) {
                effectFunction();

            } else if (typeof this.options.content === "string") {
                this.element.html(this.options.content);
                effectFunction();

            } else if (typeof this.options.content === "object" && !this.options.content.url) {
                this.element.append(this.options.content.clone().show());
                effectFunction();

            } else if (typeof this.options.content === "object" && this.options.content.url) {

                var ajaxOptions = $.extend(true, {}, this.options.content);

                var customSuccess = ajaxOptions.success;
                var customComplete = ajaxOptions.complete;
                var customError = ajaxOptions.error;

                ajaxOptions.success = function (data, textStatus, jqXHR) {

                    !customSuccess ? self.element.html(data) : customSuccess(self, data, textStatus, jqXHR);
                    effectFunction();
                };

                ajaxOptions.error = function (jqXHR, textStatus, errorThrown) {

                    self._setError("An error is triggered during the ajax request! Text: " + textStatus + " " + errorThrown);
                    customError && customError(jqXHR, textStatus, errorThrown);
                };

                ajaxOptions.complete = function (jqXHR, textStatus) {

                    customComplete && customComplete(jqXHR, textStatus);
                };

                $.ajax(ajaxOptions);

            } else {
                effectFunction();
            }
        }
    });

    $.fn.toFollow = function (opts) {

        opts = $.extend({}, opts);
        if (!opts.twitter) opts.twitter = {};
        opts.twitter.type = 'follow';
        $(this).toTweet(opts);
    };

    /**
    * [obsolete]
    */
    $.fn.totweet = function (opts) {

        opts = $.extend({}, opts);
        $(this).toTweet(opts);
    };

    /**
    * [obsolete]
    */
    $.fn.tofollow = function (opts) {

        opts = $.extend({}, opts);
        $(this).toFollow(opts);
    };

})(jQuery);

(function ($) {

    /**
    * Local Storage / Cookie state provider.
    */
    $.onepress.localTwitterStoreStateProvider = function (url, api, demo) {

        this.url = url;
        this.identity = "page_" + $.onepress.tools.hash(url) + "_tw";

        this.isUsable = function (callback) { callback(true); };

        this.lock = function () { };

        this.isUnlocked = function () {
            if (demo) return false;
            return (this._getValue()) ? true : false;
        };

        this.isLocked = function () {
            return !this.isUnlocked();
        };

        this.getState = function (callback) {
            callback(this.isUnlocked());
        };

        this.setState = function (value) {
            if (demo) return false;
            return value == "unlocked" ? this._setValue() : this._removeValue();
        };

        this._setValue = function () {

            if (localStorage) {
                localStorage.setItem(this.identity, true);
            } else {
                $.onepress.tools.cookie(this.identity, true, { expires: 356 * 10, path: "/" });
            }
        };

        this._getValue = function () {

            if (localStorage) {
                var value = localStorage.getItem(this.identity);
                if (value) return value;
                value = $.onepress.tools.cookie(this.identity);
                if (value) this._setValue();
                return value;
            } else {
                return $.onepress.tools.cookie(this.identity);
            }
        };

        this._removeValue = function () {
            if (localStorage) localStorage.removeItem(this.identity);
            $.onepress.tools.cookie(this.identity, null);
        };
    };

})(jQuery);;;

